blob: 489326dbdf2a623242b04bb6c7c08d6d8f79a0d0 [file] [log] [blame]
garciadeblasd8bc5c32018-05-09 17:37:56 +02001#!/bin/bash
garciadeblasd8bc5c32018-05-09 17:37:56 +02002#
3# Licensed under the Apache License, Version 2.0 (the "License");
4# you may not use this file except in compliance with the License.
5# You may obtain a copy of the License at
6#
7# http://www.apache.org/licenses/LICENSE-2.0
8#
9# Unless required by applicable law or agreed to in writing, software
10# distributed under the License is distributed on an "AS IS" BASIS,
11# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12# See the License for the specific language governing permissions and
13# limitations under the License.
garciadeblas0bc87522021-10-20 22:16:17 +020014#
garciadeblasd8bc5c32018-05-09 17:37:56 +020015
16function usage(){
garciadeblas0bc87522021-10-20 22:16:17 +020017 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd8bc5c32018-05-09 17:37:56 +020018 echo -e "usage: $0 [OPTIONS]"
19 echo -e "Install OSM from binaries or source code (by default, from binaries)"
20 echo -e " OPTIONS"
garciadeblas7f1e1042020-11-30 14:07:03 +000021 echo -e " -h / --help: print this help"
22 echo -e " -y: do not prompt for confirmation, assumes yes"
garciadeblasd8bc5c32018-05-09 17:37:56 +020023 echo -e " -r <repo>: use specified repository name for osm packages"
24 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
25 echo -e " -u <repo base>: use specified repository url for osm packages"
26 echo -e " -k <repo key>: use specified repository public key url"
27 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
28 echo -e " -b master (main dev branch)"
29 echo -e " -b v2.0 (v2.0 branch)"
30 echo -e " -b tags/v1.1.0 (a specific tag)"
31 echo -e " ..."
garciadeblas0bc87522021-10-20 22:16:17 +020032 echo -e " -a <apt proxy url>: use this apt proxy url when downloading apt packages (air-gapped installation)"
vijaynag8339ed22019-07-25 17:10:58 +053033 echo -e " -s <stack name> or <namespace> user defined stack name when installed using swarm or namespace when installed using k8s, default is osm"
Mike Marchettib8420852018-09-13 13:45:06 -040034 echo -e " -H <VCA host> use specific juju host controller IP"
35 echo -e " -S <VCA secret> use VCA/juju secret key"
garciadeblasaa3ddf42019-04-04 19:04:32 +020036 echo -e " -P <VCA pubkey> use VCA/juju public key file"
Adam Israel5ddc97f2019-09-03 18:11:12 -040037 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
magnussonl1bbe9452020-02-25 13:43:17 +010038 echo -e " --pla: install the PLA module for placement support"
garciadeblas7b53d262022-11-04 23:18:48 +010039 echo -e " --ng-sa: install Airflow and Pushgateway to get VNF and NS status (experimental)"
beierlmcca93642021-05-03 16:29:14 -040040 echo -e " -m <MODULE>: install OSM but only rebuild or pull the specified docker images (NG-UI, NBI, LCM, RO, MON, POL, PLA, KAFKA, MONGO, PROMETHEUS, PROMETHEUS-CADVISOR, KEYSTONE-DB, NONE)"
garciadeblasfa3eb332022-11-15 14:11:56 +010041 echo -e " -o <ADDON>: ONLY (un)installs one of the addons (k8s_monitor, ng-sa)"
Antonio Marsico75a38c72020-12-21 17:29:42 +010042 echo -e " -O <openrc file path/cloud name>: Install OSM to an OpenStack infrastructure. <openrc file/cloud name> is required. If a <cloud name> is used, the clouds.yaml file should be under ~/.config/openstack/ or /etc/openstack/"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +020043 echo -e " -N <openstack public network name/ID>: Public network name required to setup OSM to OpenStack"
Antonio Marsico75a38c72020-12-21 17:29:42 +010044 echo -e " -f <path to SSH public key>: Public SSH key to use to deploy OSM to OpenStack"
45 echo -e " -F <path to cloud-init file>: Cloud-Init userdata file to deploy OSM to OpenStack"
garciadeblase990f662018-05-18 11:43:39 +020046 echo -e " -D <devops path> use local devops installation path"
Mike Marchettib8420852018-09-13 13:45:06 -040047 echo -e " -w <work dir> Location to store runtime installation"
Mike Marchetti13d76c82018-09-19 15:00:36 -040048 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
David Garcia79f4f532020-04-07 12:59:34 +020049 echo -e " -l: LXD cloud yaml file"
50 echo -e " -L: LXD credentials yaml file"
David Garcia404ae122020-04-28 11:47:55 +020051 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
garciadeblas7f1e1042020-11-30 14:07:03 +000052 echo -e " -d <docker registry URL> use docker registry URL instead of dockerhub"
53 echo -e " -p <docker proxy URL> set docker proxy URL as part of docker CE configuration"
54 echo -e " -T <docker tag> specify docker tag for the modules specified with option -m"
garciadeblas0bc87522021-10-20 22:16:17 +020055 echo -e " --debug: debug mode"
garciadeblas9a510862021-04-21 14:15:56 +020056 echo -e " --nocachelxdimages: do not cache local lxd images, do not create cronjob for that cache (will save installation time, might affect instantiation time)"
garciadeblas0bc87522021-10-20 22:16:17 +020057 echo -e " --cachelxdimages: cache local lxd images, create cronjob for that cache (will make installation longer)"
David Garcia79f4f532020-04-07 12:59:34 +020058 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
garciadeblasa3e26612018-05-30 17:58:55 +020059 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
Mike Marchettib8420852018-09-13 13:45:06 -040060 echo -e " --nojuju: do not juju, assumes already installed"
61 echo -e " --nodockerbuild:do not build docker images (use existing locally cached images)"
62 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
63 echo -e " --nohostclient: do not install the osmclient"
garciadeblase990f662018-05-18 11:43:39 +020064 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
65 echo -e " --source: install OSM from source code using the latest stable tag"
garciadeblasd8bc5c32018-05-09 17:37:56 +020066 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
Mike Marchettida8a9c42018-10-01 15:25:15 -040067 echo -e " --pullimages: pull/run osm images from docker.io/opensourcemano"
romeromonser599d5e22020-03-06 10:23:29 +010068 echo -e " --k8s_monitor: install the OSM kubernetes monitoring with prometheus and grafana"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +020069 echo -e " --volume: create a VM volume when installing to OpenStack"
garciadeblasd8bc5c32018-05-09 17:37:56 +020070 echo -e " --showopts: print chosen options and exit (only for debugging)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020071 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
72 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
73 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020074 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
aticig5d19ac22022-05-06 13:46:22 +030075 echo -e " [--small-profile]: Do not install and configure LXD which aims to use only K8s Clouds (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020076 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020077 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
78 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
David Garcia4bd2bf02021-05-05 19:01:43 +020079 echo -e " [--overlay]: Add an overlay to override some defaults of the default bundle (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020080 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
beierlmf2782c52020-11-05 17:04:05 -050081 echo -e " [--tag]: Docker image tag. (--charmed option)"
82 echo -e " [--registry]: Docker registry with optional credentials as user:pass@hostname:port (--charmed option)"
garciadeblas0bc87522021-10-20 22:16:17 +020083 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +020084}
85
Mike Marchettib8420852018-09-13 13:45:06 -040086# takes a juju/accounts.yaml file and returns the password specific
Adam Israel8232e562018-11-21 16:47:45 -050087# for a controller. I wrote this using only bash tools to minimize
Mike Marchettib8420852018-09-13 13:45:06 -040088# additions of other packages
89function parse_juju_password {
garciadeblas0bc87522021-10-20 22:16:17 +020090 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
91 password_file="${HOME}/.local/share/juju/accounts.yaml"
92 local controller_name=$1
93 local s='[[:space:]]*' w='[a-zA-Z0-9_-]*' fs=$(echo @|tr @ '\034')
94 sed -ne "s|^\($s\):|\1|" \
95 -e "s|^\($s\)\($w\)$s:$s[\"']\(.*\)[\"']$s\$|\1$fs\2$fs\3|p" \
96 -e "s|^\($s\)\($w\)$s:$s\(.*\)$s\$|\1$fs\2$fs\3|p" $password_file |
97 awk -F$fs -v controller=$controller_name '{
98 indent = length($1)/2;
99 vname[indent] = $2;
100 for (i in vname) {if (i > indent) {delete vname[i]}}
101 if (length($3) > 0) {
102 vn=""; for (i=0; i<indent; i++) {vn=(vn)(vname[i])("_")}
103 if (match(vn,controller) && match($2,"password")) {
104 printf("%s",$3);
105 }
106 }
107 }'
108 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
109}
110
111function set_vca_variables() {
112 OSM_VCA_CLOUDNAME="lxd-cloud"
113 [ -n "$OSM_VCA_HOST" ] && OSM_VCA_CLOUDNAME="localhost"
114 if [ -z "$OSM_VCA_HOST" ]; then
115 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`sg lxd -c "juju show-controller $OSM_STACK_NAME"|grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
116 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`juju show-controller $CONTROLLER_NAME |grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
117 [ -z "$OSM_VCA_HOST" ] && FATAL "Cannot obtain juju controller IP address"
118 fi
119 if [ -z "$OSM_VCA_SECRET" ]; then
120 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_SECRET=$(parse_juju_password $OSM_STACK_NAME)
121 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_SECRET=$(parse_juju_password $CONTROLLER_NAME)
122 [ -z "$OSM_VCA_SECRET" ] && FATAL "Cannot obtain juju secret"
123 fi
124 if [ -z "$OSM_VCA_PUBKEY" ]; then
125 OSM_VCA_PUBKEY=$(cat $HOME/.local/share/juju/ssh/juju_id_rsa.pub)
126 [ -z "$OSM_VCA_PUBKEY" ] && FATAL "Cannot obtain juju public key"
127 fi
128 if [ -z "$OSM_VCA_CACERT" ]; then
129 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_CACERT=$(juju controllers --format json | jq -r --arg controller $OSM_STACK_NAME '.controllers[$controller]["ca-cert"]' | base64 | tr -d \\n)
130 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_CACERT=$(juju controllers --format json | jq -r --arg controller $CONTROLLER_NAME '.controllers[$controller]["ca-cert"]' | base64 | tr -d \\n)
131 [ -z "$OSM_VCA_CACERT" ] && FATAL "Cannot obtain juju CA certificate"
132 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400133}
134
Benjamin Diazba2cca92018-11-08 21:07:15 -0300135function generate_secret() {
garciadeblas0bc87522021-10-20 22:16:17 +0200136 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
Benjamin Diazba2cca92018-11-08 21:07:15 -0300137 head /dev/urandom | tr -dc A-Za-z0-9 | head -c 32
garciadeblas0bc87522021-10-20 22:16:17 +0200138 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
calvinosanc10c82da02020-08-17 11:45:15 +0200139}
140
beierlm2ce2b002021-12-07 16:02:22 -0500141function check_packages() {
142 NEEDED_PACKAGES="$1"
143 echo -e "Checking required packages: ${NEEDED_PACKAGES}"
144 for PACKAGE in ${NEEDED_PACKAGES} ; do
garciadeblas835088e2022-01-28 11:25:18 +0100145 dpkg -L ${PACKAGE}
beierlm2ce2b002021-12-07 16:02:22 -0500146 if [ $? -ne 0 ]; then
garciadeblas835088e2022-01-28 11:25:18 +0100147 echo -e "Package ${PACKAGE} is not installed."
148 echo -e "Updating apt-cache ..."
beierlm2ce2b002021-12-07 16:02:22 -0500149 sudo apt-get update
garciadeblas835088e2022-01-28 11:25:18 +0100150 echo -e "Installing ${PACKAGE} ..."
beierlm2ce2b002021-12-07 16:02:22 -0500151 sudo apt-get install -y ${PACKAGE} || FATAL "failed to install ${PACKAGE}"
152 fi
153 done
154 echo -e "Required packages are present: ${NEEDED_PACKAGES}"
155}
156
garciadeblasd8bc5c32018-05-09 17:37:56 +0200157function ask_user(){
158 # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive
159 # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed
160 # Return: true(0) if user type 'yes'; false (1) if user type 'no'
garciadeblas0bc87522021-10-20 22:16:17 +0200161 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200162 read -e -p "$1" USER_CONFIRMATION
163 while true ; do
164 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0
165 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1
166 [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0
167 [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1
168 read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION
169 done
garciadeblas0bc87522021-10-20 22:16:17 +0200170 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200171}
172
garciadeblasd8bc5c32018-05-09 17:37:56 +0200173function install_osmclient(){
garciadeblas0bc87522021-10-20 22:16:17 +0200174 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200175 CLIENT_RELEASE=${RELEASE#"-R "}
176 CLIENT_REPOSITORY_KEY="OSM%20ETSI%20Release%20Key.gpg"
177 CLIENT_REPOSITORY=${REPOSITORY#"-r "}
garciadeblasd8bc5c32018-05-09 17:37:56 +0200178 CLIENT_REPOSITORY_BASE=${REPOSITORY_BASE#"-u "}
179 key_location=$CLIENT_REPOSITORY_BASE/$CLIENT_RELEASE/$CLIENT_REPOSITORY_KEY
garciadeblas0bc87522021-10-20 22:16:17 +0200180 curl $key_location | sudo APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE=1 apt-key add -
garciadeblas078f5982019-11-27 15:06:06 +0100181 sudo add-apt-repository -y "deb [arch=amd64] $CLIENT_REPOSITORY_BASE/$CLIENT_RELEASE $CLIENT_REPOSITORY osmclient IM"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200182 sudo apt-get update
garciadeblas078f5982019-11-27 15:06:06 +0100183 sudo apt-get install -y python3-pip
184 sudo -H LC_ALL=C python3 -m pip install -U pip
garciadeblasa9954892020-01-22 16:05:05 +0100185 sudo -H LC_ALL=C python3 -m pip install -U python-magic pyangbind verboselogs
garciadeblasda89ee72019-11-28 02:19:59 +0100186 sudo apt-get install -y python3-osm-im python3-osmclient
beierlm920d7562021-04-21 05:13:53 -0400187 if [ -f /usr/lib/python3/dist-packages/osm_im/requirements.txt ]; then
beierlm021b3072021-04-27 14:33:24 -0400188 python3 -m pip install -r /usr/lib/python3/dist-packages/osm_im/requirements.txt
beierlm920d7562021-04-21 05:13:53 -0400189 fi
190 if [ -f /usr/lib/python3/dist-packages/osmclient/requirements.txt ]; then
garciadeblas56005542022-08-29 14:56:02 +0200191 sudo apt-get install -y libcurl4-openssl-dev libssl-dev libmagic1
beierlm021b3072021-04-27 14:33:24 -0400192 python3 -m pip install -r /usr/lib/python3/dist-packages/osmclient/requirements.txt
beierlm920d7562021-04-21 05:13:53 -0400193 fi
garciadeblasd8bc5c32018-05-09 17:37:56 +0200194 [ -z "$INSTALL_LIGHTWEIGHT" ] && export OSM_HOSTNAME=`lxc list | awk '($2=="SO-ub"){print $6}'`
195 [ -z "$INSTALL_LIGHTWEIGHT" ] && export OSM_RO_HOSTNAME=`lxc list | awk '($2=="RO"){print $6}'`
garciadeblasd8bc5c32018-05-09 17:37:56 +0200196 echo -e "\nOSM client installed"
garciadeblasc3226982018-11-27 11:32:47 +0100197 if [ -z "$INSTALL_LIGHTWEIGHT" ]; then
198 echo -e "You might be interested in adding the following OSM client env variables to your .bashrc file:"
199 echo " export OSM_HOSTNAME=${OSM_HOSTNAME}"
200 echo " export OSM_RO_HOSTNAME=${OSM_RO_HOSTNAME}"
201 else
202 echo -e "OSM client assumes that OSM host is running in localhost (127.0.0.1)."
203 echo -e "In case you want to interact with a different OSM host, you will have to configure this env variable in your .bashrc file:"
204 echo " export OSM_HOSTNAME=<OSM_host>"
205 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200206 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200207 return 0
208}
209
garciadeblas453d4582020-12-16 19:03:10 +0100210function docker_login() {
garciadeblas0bc87522021-10-20 22:16:17 +0200211 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas453d4582020-12-16 19:03:10 +0100212 echo "Docker login"
garciadeblas0bc87522021-10-20 22:16:17 +0200213 [ -z "${DEBUG_INSTALL}" ] || DEBUG "Docker registry user: ${DOCKER_REGISTRY_USER}"
214 sg docker -c "docker login -u ${DOCKER_REGISTRY_USER} -p ${DOCKER_REGISTRY_PASSWORD} --password-stdin"
215 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas453d4582020-12-16 19:03:10 +0100216}
217
garciadeblasd8bc5c32018-05-09 17:37:56 +0200218function generate_docker_images() {
garciadeblas0bc87522021-10-20 22:16:17 +0200219 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200220 echo "Pulling and generating docker images"
garciadeblas453d4582020-12-16 19:03:10 +0100221 [ -n "${DOCKER_REGISTRY_URL}" ] && docker_login
Michael Marchettiee374142018-08-02 22:47:16 +0200222
garciadeblas7f1e1042020-11-30 14:07:03 +0000223 echo "Pulling docker images"
lavado60216242018-10-10 23:44:28 +0200224
garciadeblas0e596bc2018-05-28 16:04:42 +0200225 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q KAFKA ; then
226 sg docker -c "docker pull wurstmeister/zookeeper" || FATAL "cannot get zookeeper docker image"
Benjamin Diazaa0af712018-10-04 14:02:34 -0300227 sg docker -c "docker pull wurstmeister/kafka:${KAFKA_TAG}" || FATAL "cannot get kafka docker image"
garciadeblas0e596bc2018-05-28 16:04:42 +0200228 fi
Mike Marchettida8a9c42018-10-01 15:25:15 -0400229
lavado60216242018-10-10 23:44:28 +0200230 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q PROMETHEUS ; then
231 sg docker -c "docker pull prom/prometheus:${PROMETHEUS_TAG}" || FATAL "cannot get prometheus docker image"
232 fi
233
garciadeblasfc5bb142019-12-10 10:49:12 +0100234 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q PROMETHEUS-CADVISOR ; then
235 sg docker -c "docker pull google/cadvisor:${PROMETHEUS_CADVISOR_TAG}" || FATAL "cannot get prometheus cadvisor docker image"
236 fi
237
lavado6ad812e2019-11-29 10:58:58 -0500238 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q GRAFANA ; then
239 sg docker -c "docker pull grafana/grafana:${GRAFANA_TAG}" || FATAL "cannot get grafana docker image"
garciadeblas0ab16612022-02-22 14:23:57 +0100240 sg docker -c "docker pull kiwigrid/k8s-sidecar:${KIWIGRID_K8S_SIDECAR_TAG}" || FATAL "cannot get kiwigrid k8s-sidecar docker image"
garciadeblasfc5bb142019-12-10 10:49:12 +0100241 fi
lavado6ad812e2019-11-29 10:58:58 -0500242
garciadeblas4a83e6e2018-12-04 14:55:09 +0100243 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q NBI || echo $TO_REBUILD | grep -q KEYSTONE-DB ; then
lavado9a8df7c2018-10-24 09:35:34 -0500244 sg docker -c "docker pull mariadb:${KEYSTONEDB_TAG}" || FATAL "cannot get keystone-db docker image"
245 fi
246
garciadeblas4a83e6e2018-12-04 14:55:09 +0100247 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q RO ; then
248 sg docker -c "docker pull mysql:5" || FATAL "cannot get mysql docker image"
249 fi
250
Mike Marchettida8a9c42018-10-01 15:25:15 -0400251 if [ -n "$PULL_IMAGES" ]; then
garciadeblas7f1e1042020-11-30 14:07:03 +0000252 echo "Pulling OSM docker images"
beierlmcca93642021-05-03 16:29:14 -0400253 for module in MON POL NBI KEYSTONE RO LCM NG-UI PLA osmclient; do
garciadeblas7f1e1042020-11-30 14:07:03 +0000254 module_lower=${module,,}
garciadeblas7f1e1042020-11-30 14:07:03 +0000255 if [ $module == "PLA" -a ! -n "$INSTALL_PLA" ]; then
256 continue
257 fi
beierlm920d7562021-04-21 05:13:53 -0400258 module_tag="${OSM_DOCKER_TAG}"
garciadeblas7f1e1042020-11-30 14:07:03 +0000259 if [ -n "${MODULE_DOCKER_TAG}" ] && echo $TO_REBUILD | grep -q $module ; then
260 module_tag="${MODULE_DOCKER_TAG}"
261 fi
beierlm920d7562021-04-21 05:13:53 -0400262 echo "Pulling ${DOCKER_REGISTRY_URL}${DOCKER_USER}/${module_lower}:${module_tag} docker image"
garciadeblas7f1e1042020-11-30 14:07:03 +0000263 sg docker -c "docker pull ${DOCKER_REGISTRY_URL}${DOCKER_USER}/${module_lower}:${module_tag}" || FATAL "cannot pull $module docker image"
264 done
vijaynag4b57d462020-06-08 14:23:10 +0000265 else
garciadeblas7f1e1042020-11-30 14:07:03 +0000266 _build_from=$COMMIT_ID
267 [ -z "$_build_from" ] && _build_from="latest"
268 echo "OSM Docker images generated from $_build_from"
garciadeblas0bc87522021-10-20 22:16:17 +0200269 LWTEMPDIR="$(mktemp -d -q --tmpdir "installosmlight.XXXXXX")"
270 trap 'rm -rf "${LWTEMPDIR}"' EXIT
beierlmcca93642021-05-03 16:29:14 -0400271 for module in MON POL NBI KEYSTONE RO LCM NG-UI PLA; do
garciadeblas7f1e1042020-11-30 14:07:03 +0000272 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q ${module} ; then
273 module_lower=${module,,}
garciadeblas7f1e1042020-11-30 14:07:03 +0000274 if [ $module == "PLA" -a ! -n "$INSTALL_PLA" ]; then
275 continue
276 fi
277 git -C ${LWTEMPDIR} clone https://osm.etsi.org/gerrit/osm/$module
278 git -C ${LWTEMPDIR}/${module} checkout ${COMMIT_ID}
279 sg docker -c "docker build ${LWTEMPDIR}/${module} -f ${LWTEMPDIR}/${module}/docker/Dockerfile -t ${DOCKER_USER}/${module_lower} --no-cache" || FATAL "cannot build ${module} docker image"
280 fi
281 done
282 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q osmclient; then
283 BUILD_ARGS+=(--build-arg REPOSITORY="$REPOSITORY")
284 BUILD_ARGS+=(--build-arg RELEASE="$RELEASE")
285 BUILD_ARGS+=(--build-arg REPOSITORY_KEY="$REPOSITORY_KEY")
286 BUILD_ARGS+=(--build-arg REPOSITORY_BASE="$REPOSITORY_BASE")
287 sg docker -c "docker build -t ${DOCKER_USER}/osmclient ${BUILD_ARGS[@]} -f $OSM_DEVOPS/docker/osmclient ."
vijaynag4b57d462020-06-08 14:23:10 +0000288 fi
garciadeblas7f1e1042020-11-30 14:07:03 +0000289 echo "Finished generation of docker images"
Mike Marchettib8420852018-09-13 13:45:06 -0400290 fi
lavado6ad812e2019-11-29 10:58:58 -0500291
garciadeblas7f1e1042020-11-30 14:07:03 +0000292 echo "Finished pulling and generating docker images"
garciadeblas0bc87522021-10-20 22:16:17 +0200293 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200294}
295
garciadeblas5b857d32018-05-24 18:37:58 +0200296function cmp_overwrite() {
garciadeblas0bc87522021-10-20 22:16:17 +0200297 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas5b857d32018-05-24 18:37:58 +0200298 file1="$1"
299 file2="$2"
300 if ! $(cmp "${file1}" "${file2}" >/dev/null 2>&1); then
301 if [ -f "${file2}" ]; then
Mike Marchettib8420852018-09-13 13:45:06 -0400302 ask_user "The file ${file2} already exists. Overwrite (y/N)? " n && cp -b ${file1} ${file2}
garciadeblas5b857d32018-05-24 18:37:58 +0200303 else
Mike Marchettib8420852018-09-13 13:45:06 -0400304 cp -b ${file1} ${file2}
garciadeblas5b857d32018-05-24 18:37:58 +0200305 fi
306 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200307 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
beierlma4a37f72020-06-26 12:55:01 -0400308}
309
310function generate_k8s_manifest_files() {
garciadeblas0bc87522021-10-20 22:16:17 +0200311 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
beierlma4a37f72020-06-26 12:55:01 -0400312 #Kubernetes resources
garciadeblas0bc87522021-10-20 22:16:17 +0200313 sudo cp -bR ${OSM_DEVOPS}/installers/docker/osm_pods $OSM_DOCKER_WORK_DIR
garciadeblas0bc87522021-10-20 22:16:17 +0200314 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
beierlma4a37f72020-06-26 12:55:01 -0400315}
316
garciadeblasd8bc5c32018-05-09 17:37:56 +0200317function generate_docker_env_files() {
garciadeblas0bc87522021-10-20 22:16:17 +0200318 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasf9f6d9d2019-10-16 09:33:35 +0200319 echo "Doing a backup of existing env files"
garciadeblas0bc87522021-10-20 22:16:17 +0200320 sudo cp $OSM_DOCKER_WORK_DIR/keystone-db.env{,~}
321 sudo cp $OSM_DOCKER_WORK_DIR/keystone.env{,~}
322 sudo cp $OSM_DOCKER_WORK_DIR/lcm.env{,~}
323 sudo cp $OSM_DOCKER_WORK_DIR/mon.env{,~}
324 sudo cp $OSM_DOCKER_WORK_DIR/nbi.env{,~}
325 sudo cp $OSM_DOCKER_WORK_DIR/pol.env{,~}
326 sudo cp $OSM_DOCKER_WORK_DIR/ro-db.env{,~}
327 sudo cp $OSM_DOCKER_WORK_DIR/ro.env{,~}
garciadeblas7b53d262022-11-04 23:18:48 +0100328 if [ -n "${INSTALL_NGSA}" ]; then
329 sudo cp $OSM_DOCKER_WORK_DIR/ngsa.env{,~}
garciadeblasbacdfa82023-04-04 10:52:46 +0200330 sudo cp $OSM_DOCKER_WORK_DIR/webhook-translator.env{,~}
garciadeblas7b53d262022-11-04 23:18:48 +0100331 fi
garciadeblasf9f6d9d2019-10-16 09:33:35 +0200332
garciadeblasd8bc5c32018-05-09 17:37:56 +0200333 echo "Generating docker env files"
Benjamin Diazba2cca92018-11-08 21:07:15 -0300334 # LCM
335 if [ ! -f $OSM_DOCKER_WORK_DIR/lcm.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200336 echo "OSMLCM_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300337 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400338
Benjamin Diazba2cca92018-11-08 21:07:15 -0300339 if ! grep -Fq "OSMLCM_VCA_HOST" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200340 echo "OSMLCM_VCA_HOST=${OSM_VCA_HOST}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300341 else
garciadeblas0bc87522021-10-20 22:16:17 +0200342 sudo sed -i "s|OSMLCM_VCA_HOST.*|OSMLCM_VCA_HOST=$OSM_VCA_HOST|g" $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300343 fi
344
345 if ! grep -Fq "OSMLCM_VCA_SECRET" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200346 echo "OSMLCM_VCA_SECRET=${OSM_VCA_SECRET}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300347 else
garciadeblas0bc87522021-10-20 22:16:17 +0200348 sudo sed -i "s|OSMLCM_VCA_SECRET.*|OSMLCM_VCA_SECRET=$OSM_VCA_SECRET|g" $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300349 fi
350
garciadeblasaa3ddf42019-04-04 19:04:32 +0200351 if ! grep -Fq "OSMLCM_VCA_PUBKEY" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200352 echo "OSMLCM_VCA_PUBKEY=${OSM_VCA_PUBKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasaa3ddf42019-04-04 19:04:32 +0200353 else
garciadeblas0bc87522021-10-20 22:16:17 +0200354 sudo sed -i "s|OSMLCM_VCA_PUBKEY.*|OSMLCM_VCA_PUBKEY=${OSM_VCA_PUBKEY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasaa3ddf42019-04-04 19:04:32 +0200355 fi
356
Adam Israelbe7676a2019-10-02 16:10:53 -0400357 if ! grep -Fq "OSMLCM_VCA_CACERT" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200358 echo "OSMLCM_VCA_CACERT=${OSM_VCA_CACERT}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Adam Israelbe7676a2019-10-02 16:10:53 -0400359 else
garciadeblas0bc87522021-10-20 22:16:17 +0200360 sudo sed -i "s|OSMLCM_VCA_CACERT.*|OSMLCM_VCA_CACERT=${OSM_VCA_CACERT}|g" $OSM_DOCKER_WORK_DIR/lcm.env
Adam Israelbe7676a2019-10-02 16:10:53 -0400361 fi
Benjamin Diazba2cca92018-11-08 21:07:15 -0300362
David Garcia6cbfee12020-10-23 10:40:20 +0200363 if [ -n "$OSM_VCA_APIPROXY" ]; then
364 if ! grep -Fq "OSMLCM_VCA_APIPROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200365 echo "OSMLCM_VCA_APIPROXY=${OSM_VCA_APIPROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia6cbfee12020-10-23 10:40:20 +0200366 else
garciadeblas0bc87522021-10-20 22:16:17 +0200367 sudo sed -i "s|OSMLCM_VCA_APIPROXY.*|OSMLCM_VCA_APIPROXY=${OSM_VCA_APIPROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia6cbfee12020-10-23 10:40:20 +0200368 fi
Adam Israel5ddc97f2019-09-03 18:11:12 -0400369 fi
370
garciadeblasa2e41842019-12-18 11:05:24 +0100371 if ! grep -Fq "OSMLCM_VCA_ENABLEOSUPGRADE" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200372 echo "# OSMLCM_VCA_ENABLEOSUPGRADE=false" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasa2e41842019-12-18 11:05:24 +0100373 fi
374
375 if ! grep -Fq "OSMLCM_VCA_APTMIRROR" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200376 echo "# OSMLCM_VCA_APTMIRROR=http://archive.ubuntu.com/ubuntu/" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasa2e41842019-12-18 11:05:24 +0100377 fi
378
David Garcia79f4f532020-04-07 12:59:34 +0200379 if ! grep -Fq "OSMLCM_VCA_CLOUD" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200380 echo "OSMLCM_VCA_CLOUD=${OSM_VCA_CLOUDNAME}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia79f4f532020-04-07 12:59:34 +0200381 else
garciadeblas0bc87522021-10-20 22:16:17 +0200382 sudo sed -i "s|OSMLCM_VCA_CLOUD.*|OSMLCM_VCA_CLOUD=${OSM_VCA_CLOUDNAME}|g" $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia79f4f532020-04-07 12:59:34 +0200383 fi
384
beierlma4a37f72020-06-26 12:55:01 -0400385 if ! grep -Fq "OSMLCM_VCA_K8S_CLOUD" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200386 echo "OSMLCM_VCA_K8S_CLOUD=${OSM_VCA_K8S_CLOUDNAME}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
beierlma4a37f72020-06-26 12:55:01 -0400387 else
garciadeblas0bc87522021-10-20 22:16:17 +0200388 sudo sed -i "s|OSMLCM_VCA_K8S_CLOUD.*|OSMLCM_VCA_K8S_CLOUD=${OSM_VCA_K8S_CLOUDNAME}|g" $OSM_DOCKER_WORK_DIR/lcm.env
beierlma4a37f72020-06-26 12:55:01 -0400389 fi
garciadeblasfa3eb332022-11-15 14:11:56 +0100390 if [ -n "${OSM_BEHIND_PROXY}" ]; then
391 if ! grep -Fq "HTTP_PROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
392 echo "HTTP_PROXY=${HTTP_PROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
393 else
394 sudo sed -i "s|HTTP_PROXY.*|HTTP_PROXY=${HTTP_PROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
395 fi
396 if ! grep -Fq "HTTPS_PROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
397 echo "HTTPS_PROXY=${HTTPS_PROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
398 else
399 sudo sed -i "s|HTTPS_PROXY.*|HTTPS_PROXY=${HTTPS_PROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
400 fi
401 if ! grep -Fq "NO_PROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
402 echo "NO_PROXY=${NO_PROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
403 else
404 sudo sed -i "s|NO_PROXY.*|NO_PROXY=${NO_PROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
405 fi
406 fi
beierlma4a37f72020-06-26 12:55:01 -0400407
Benjamin Diazba2cca92018-11-08 21:07:15 -0300408 # RO
409 MYSQL_ROOT_PASSWORD=$(generate_secret)
Mike Marchettib8420852018-09-13 13:45:06 -0400410 if [ ! -f $OSM_DOCKER_WORK_DIR/ro-db.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200411 echo "MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/ro-db.env
garciadeblas5b857d32018-05-24 18:37:58 +0200412 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400413 if [ ! -f $OSM_DOCKER_WORK_DIR/ro.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200414 echo "RO_DB_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/ro.env
garciadeblas5b857d32018-05-24 18:37:58 +0200415 fi
tierno9ec1fe92020-11-25 13:16:51 +0000416 if ! grep -Fq "OSMRO_DATABASE_COMMONKEY" $OSM_DOCKER_WORK_DIR/ro.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200417 echo "OSMRO_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/ro.env
tierno9ec1fe92020-11-25 13:16:51 +0000418 fi
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100419
Benjamin Diazba2cca92018-11-08 21:07:15 -0300420 # Keystone
Benjamin Diazba2cca92018-11-08 21:07:15 -0300421 KEYSTONE_DB_PASSWORD=$(generate_secret)
Eduardo Sousac50ed8f2019-04-08 17:17:54 +0100422 SERVICE_PASSWORD=$(generate_secret)
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100423 if [ ! -f $OSM_DOCKER_WORK_DIR/keystone-db.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200424 echo "MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/keystone-db.env
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100425 fi
426 if [ ! -f $OSM_DOCKER_WORK_DIR/keystone.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200427 echo "ROOT_DB_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/keystone.env
428 echo "KEYSTONE_DB_PASSWORD=${KEYSTONE_DB_PASSWORD}" |sudo tee -a $OSM_DOCKER_WORK_DIR/keystone.env
429 echo "SERVICE_PASSWORD=${SERVICE_PASSWORD}" |sudo tee -a $OSM_DOCKER_WORK_DIR/keystone.env
Eduardo Sousae193dfd2018-09-21 11:37:49 +0100430 fi
431
Benjamin Diazba2cca92018-11-08 21:07:15 -0300432 # NBI
Eduardo Sousae193dfd2018-09-21 11:37:49 +0100433 if [ ! -f $OSM_DOCKER_WORK_DIR/nbi.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200434 echo "OSMNBI_AUTHENTICATION_SERVICE_PASSWORD=${SERVICE_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/nbi.env
435 echo "OSMNBI_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/nbi.env
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100436 fi
437
Benjamin Diazba2cca92018-11-08 21:07:15 -0300438 # MON
439 if [ ! -f $OSM_DOCKER_WORK_DIR/mon.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200440 echo "OSMMON_KEYSTONE_SERVICE_PASSWORD=${SERVICE_PASSWORD}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
441 echo "OSMMON_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
442 echo "OSMMON_SQL_DATABASE_URI=mysql://root:${MYSQL_ROOT_PASSWORD}@mysql:3306/mon" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300443 fi
444
445 if ! grep -Fq "OS_NOTIFIER_URI" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas45ab04c2022-11-25 10:59:03 +0100446 echo "OS_NOTIFIER_URI=http://${OSM_DEFAULT_IP}:8662" |sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300447 else
garciadeblas45ab04c2022-11-25 10:59:03 +0100448 sudo sed -i "s|OS_NOTIFIER_URI.*|OS_NOTIFIER_URI=http://$OSM_DEFAULT_IP:8662|g" $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300449 fi
450
451 if ! grep -Fq "OSMMON_VCA_HOST" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200452 echo "OSMMON_VCA_HOST=${OSM_VCA_HOST}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300453 else
garciadeblas0bc87522021-10-20 22:16:17 +0200454 sudo sed -i "s|OSMMON_VCA_HOST.*|OSMMON_VCA_HOST=$OSM_VCA_HOST|g" $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300455 fi
456
457 if ! grep -Fq "OSMMON_VCA_SECRET" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200458 echo "OSMMON_VCA_SECRET=${OSM_VCA_SECRET}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300459 else
garciadeblas0bc87522021-10-20 22:16:17 +0200460 sudo sed -i "s|OSMMON_VCA_SECRET.*|OSMMON_VCA_SECRET=$OSM_VCA_SECRET|g" $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300461 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400462
Adam Israel6d8adf32019-12-05 15:46:54 -0500463 if ! grep -Fq "OSMMON_VCA_CACERT" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200464 echo "OSMMON_VCA_CACERT=${OSM_VCA_CACERT}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Adam Israel6d8adf32019-12-05 15:46:54 -0500465 else
garciadeblas0bc87522021-10-20 22:16:17 +0200466 sudo sed -i "s|OSMMON_VCA_CACERT.*|OSMMON_VCA_CACERT=${OSM_VCA_CACERT}|g" $OSM_DOCKER_WORK_DIR/mon.env
Adam Israel6d8adf32019-12-05 15:46:54 -0500467 fi
468
Benjamin Diaz04560882019-02-26 17:25:07 -0300469 # POL
470 if [ ! -f $OSM_DOCKER_WORK_DIR/pol.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200471 echo "OSMPOL_SQL_DATABASE_URI=mysql://root:${MYSQL_ROOT_PASSWORD}@mysql:3306/pol" | sudo tee -a $OSM_DOCKER_WORK_DIR/pol.env
Benjamin Diaz04560882019-02-26 17:25:07 -0300472 fi
473
garciadeblas7b53d262022-11-04 23:18:48 +0100474 # NG-SA
475 if [ -n "${INSTALL_NGSA}" ] && [ ! -f $OSM_DOCKER_WORK_DIR/ngsa.env ]; then
476 echo "OSMMON_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/ngsa.env
477 fi
478
garciadeblasbacdfa82023-04-04 10:52:46 +0200479 # Webhook-translator
480 if [ -n "${INSTALL_NGSA}" ] && [ ! -f $OSM_DOCKER_WORK_DIR/webhook-translator.env ]; then
481 echo "AIRFLOW_HOST=airflow-webserver" | sudo tee -a $OSM_DOCKER_WORK_DIR/webhook-translator.env
482 echo "AIRFLOW_PORT=8080" | sudo tee -a $OSM_DOCKER_WORK_DIR/webhook-translator.env
483 echo "AIRFLOW_USER=admin" | sudo tee -a $OSM_DOCKER_WORK_DIR/webhook-translator.env
484 echo "AIRFLOW_PASS=admin" | sudo tee -a $OSM_DOCKER_WORK_DIR/webhook-translator.env
485 fi
486
garciadeblasd8bc5c32018-05-09 17:37:56 +0200487 echo "Finished generation of docker env files"
garciadeblas0bc87522021-10-20 22:16:17 +0200488 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
vijaynag8339ed22019-07-25 17:10:58 +0530489}
490
491#creates secrets from env files which will be used by containers
492function kube_secrets(){
garciadeblas0bc87522021-10-20 22:16:17 +0200493 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
vijaynag8339ed22019-07-25 17:10:58 +0530494 kubectl create ns $OSM_STACK_NAME
495 kubectl create secret generic lcm-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/lcm.env
496 kubectl create secret generic mon-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/mon.env
497 kubectl create secret generic nbi-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/nbi.env
498 kubectl create secret generic ro-db-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/ro-db.env
499 kubectl create secret generic ro-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/ro.env
500 kubectl create secret generic keystone-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/keystone.env
vijaynag8339ed22019-07-25 17:10:58 +0530501 kubectl create secret generic pol-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/pol.env
garciadeblas7b53d262022-11-04 23:18:48 +0100502 if [ -n "${INSTALL_NGSA}" ]; then
503 kubectl create secret generic ngsa-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/ngsa.env
garciadeblasbacdfa82023-04-04 10:52:46 +0200504 kubectl create secret generic webhook-translator-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/webhook-translator.env
garciadeblas7b53d262022-11-04 23:18:48 +0100505 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200506 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasf6ed60c2020-07-08 14:30:29 +0000507}
508
509#deploys osm pods and services
510function deploy_osm_services() {
garciadeblas0bc87522021-10-20 22:16:17 +0200511 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
vijaynag8339ed22019-07-25 17:10:58 +0530512 kubectl apply -n $OSM_STACK_NAME -f $OSM_K8S_WORK_DIR
garciadeblas0bc87522021-10-20 22:16:17 +0200513 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
vijaynag8339ed22019-07-25 17:10:58 +0530514}
515
David Garciaa1376012020-10-19 15:42:42 +0200516#deploy charmed services
517function deploy_charmed_services() {
garciadeblas0bc87522021-10-20 22:16:17 +0200518 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
David Garciaa1376012020-10-19 15:42:42 +0200519 juju add-model $OSM_STACK_NAME $OSM_VCA_K8S_CLOUDNAME
David Garciad68e0b42021-06-28 16:50:42 +0200520 juju deploy ch:mongodb-k8s -m $OSM_STACK_NAME
garciadeblas0bc87522021-10-20 22:16:17 +0200521 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
David Garciaa1376012020-10-19 15:42:42 +0200522}
523
magnussonl1bbe9452020-02-25 13:43:17 +0100524function deploy_osm_pla_service() {
garciadeblas0bc87522021-10-20 22:16:17 +0200525 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
magnussonl1bbe9452020-02-25 13:43:17 +0100526 # corresponding to deploy_osm_services
527 kubectl apply -n $OSM_STACK_NAME -f $OSM_DOCKER_WORK_DIR/osm_pla
garciadeblas0bc87522021-10-20 22:16:17 +0200528 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
romeromonser599d5e22020-03-06 10:23:29 +0100529}
530
garciadeblas7b53d262022-11-04 23:18:48 +0100531function install_osm_ngsa_service() {
532 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd2d00c72022-11-25 17:21:46 +0100533 $OSM_DEVOPS/installers/install_ngsa.sh -d ${OSM_HELM_WORK_DIR} -D ${OSM_DEVOPS} -t ${OSM_DOCKER_TAG} ${DEBUG_INSTALL} || \
garciadeblas7b53d262022-11-04 23:18:48 +0100534 FATAL_TRACK install_osm_ngsa_service "install_ngsa.sh failed"
535 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
536}
537
vijaynag8339ed22019-07-25 17:10:58 +0530538function parse_yaml() {
garciadeblas0bc87522021-10-20 22:16:17 +0200539 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
vijaynag8339ed22019-07-25 17:10:58 +0530540 TAG=$1
garciadeblas7f1e1042020-11-30 14:07:03 +0000541 shift
542 services=$@
543 for module in $services; do
544 if [ "$module" == "pla" ]; then
545 if [ -n "$INSTALL_PLA" ]; then
garciadeblas7b53d262022-11-04 23:18:48 +0100546 echo "Updating K8s manifest file from opensourcemano\/pla:.* to ${DOCKER_REGISTRY_URL}${DOCKER_USER}\/pla:${TAG}"
garciadeblas0bc87522021-10-20 22:16:17 +0200547 sudo sed -i "s#opensourcemano/pla:.*#${DOCKER_REGISTRY_URL}${DOCKER_USER}/pla:${TAG}#g" ${OSM_DOCKER_WORK_DIR}/osm_pla/pla.yaml
garciadeblas7f1e1042020-11-30 14:07:03 +0000548 fi
549 else
garciadeblas7b53d262022-11-04 23:18:48 +0100550 image=${module}
551 if [ "$module" == "ng-prometheus" ]; then
552 image="prometheus"
553 fi
554 echo "Updating K8s manifest file from opensourcemano\/${image}:.* to ${DOCKER_REGISTRY_URL}${DOCKER_USER}\/${image}:${TAG}"
555 sudo sed -i "s#opensourcemano/${image}:.*#${DOCKER_REGISTRY_URL}${DOCKER_USER}/${image}:${TAG}#g" ${OSM_K8S_WORK_DIR}/${module}.yaml
garciadeblas7f1e1042020-11-30 14:07:03 +0000556 fi
vijaynag8339ed22019-07-25 17:10:58 +0530557 done
garciadeblas0bc87522021-10-20 22:16:17 +0200558 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas7f1e1042020-11-30 14:07:03 +0000559}
560
561function update_manifest_files() {
garciadeblas7b53d262022-11-04 23:18:48 +0100562 osm_services="nbi lcm ro pol mon ng-ui keystone pla prometheus ng-prometheus"
garciadeblas7f1e1042020-11-30 14:07:03 +0000563 list_of_services=""
564 for module in $osm_services; do
565 module_upper="${module^^}"
garciadeblas7f1e1042020-11-30 14:07:03 +0000566 if ! echo $TO_REBUILD | grep -q $module_upper ; then
567 list_of_services="$list_of_services $module"
568 fi
569 done
garciadeblas89c5f552022-11-24 20:16:57 +0100570 if [ ! "$OSM_DOCKER_TAG" == "13" ]; then
garciadeblas7f1e1042020-11-30 14:07:03 +0000571 parse_yaml $OSM_DOCKER_TAG $list_of_services
572 fi
573 if [ -n "$MODULE_DOCKER_TAG" ]; then
574 parse_yaml $MODULE_DOCKER_TAG $list_of_services_to_rebuild
575 fi
garciadeblas7b53d262022-11-04 23:18:48 +0100576 # The manifest for prometheus is prometheus.yaml or ng-prometheus.yaml, depending on the installation option
577 if [ -n "$INSTALL_NGSA" ]; then
578 sudo rm -f ${OSM_K8S_WORK_DIR}/prometheus.yaml
579 else
580 sudo rm -f ${OSM_K8S_WORK_DIR}/ng-prometheus.yaml
garciadeblasbacdfa82023-04-04 10:52:46 +0200581 sudo rm -f ${OSM_K8S_WORK_DIR}/webhook-translator.yaml
garciadeblas7b53d262022-11-04 23:18:48 +0100582 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200583 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
vijaynag8339ed22019-07-25 17:10:58 +0530584}
585
586function namespace_vol() {
garciadeblas0bc87522021-10-20 22:16:17 +0200587 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas7b53d262022-11-04 23:18:48 +0100588 # List of services with a volume mounted in path /var/lib/osm
589 osm_services="mysql"
vijaynag8339ed22019-07-25 17:10:58 +0530590 for osm in $osm_services; do
garciadeblas7b53d262022-11-04 23:18:48 +0100591 if [ -f "$OSM_K8S_WORK_DIR/$osm.yaml" ] ; then
592 sudo sed -i "s#path: /var/lib/osm#path: $OSM_NAMESPACE_VOL#g" $OSM_K8S_WORK_DIR/$osm.yaml
593 fi
vijaynag8339ed22019-07-25 17:10:58 +0530594 done
garciadeblas0bc87522021-10-20 22:16:17 +0200595 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas6c66abf2018-05-16 14:46:19 +0200596}
597
garciadeblase92a18d2020-07-03 16:24:23 +0000598function add_local_k8scluster() {
garciadeblas0bc87522021-10-20 22:16:17 +0200599 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblase92a18d2020-07-03 16:24:23 +0000600 /usr/bin/osm --all-projects vim-create \
601 --name _system-osm-vim \
602 --account_type dummy \
603 --auth_url http://dummy \
604 --user osm --password osm --tenant osm \
605 --description "dummy" \
606 --config '{management_network_name: mgmt}'
607 /usr/bin/osm --all-projects k8scluster-add \
608 --creds ${HOME}/.kube/config \
609 --vim _system-osm-vim \
610 --k8s-nets '{"net1": null}' \
611 --version '1.15' \
612 --description "OSM Internal Cluster" \
613 _system-osm-k8s
garciadeblas0bc87522021-10-20 22:16:17 +0200614 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblase92a18d2020-07-03 16:24:23 +0000615}
616
garciadeblas0bc87522021-10-20 22:16:17 +0200617function configure_apt_proxy() {
618 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
619 OSM_APT_PROXY=$1
620 OSM_APT_PROXY_FILE="/etc/apt/apt.conf.d/osm-apt"
621 echo "Configuring apt proxy in file ${OSM_APT_PROXY_FILE}"
622 if [ ! -f ${OSM_APT_PROXY_FILE} ]; then
623 sudo bash -c "cat <<EOF > ${OSM_APT_PROXY}
624Acquire::http { Proxy \"${OSM_APT_PROXY}\"; }
625EOF"
626 else
627 sudo sed -i "s|Proxy.*|Proxy \"${OSM_APT_PROXY}\"; }|" ${OSM_APT_PROXY_FILE}
628 fi
629 sudo apt-get update || FATAL "Configured apt proxy, but couldn't run 'apt-get update'. Check ${OSM_APT_PROXY_FILE}"
garciadeblas4d89c372021-11-25 11:57:18 +0100630 track prereq apt_proxy_configured_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200631 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
632}
633
garciadeblasfa3eb332022-11-15 14:11:56 +0100634function ask_proceed() {
garciadeblas0bc87522021-10-20 22:16:17 +0200635 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasadcf95e2022-01-28 17:15:39 +0100636
garciadeblas0bc87522021-10-20 22:16:17 +0200637 [ -z "$ASSUME_YES" ] && ! ask_user "The installation will do the following
638 1. Install and configure LXD
639 2. Install juju
640 3. Install docker CE
641 4. Disable swap space
642 5. Install and initialize Kubernetes
643 as pre-requirements.
644 Do you want to proceed (Y/n)? " y && echo "Cancelled!" && exit 1
garciadeblasfa3eb332022-11-15 14:11:56 +0100645
646 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
647}
648
649function check_osm_behind_proxy() {
650 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
651
652 export OSM_BEHIND_PROXY=""
653 export OSM_PROXY_ENV_VARIABLES=""
654 [ -n "${http_proxy}" ] && OSM_BEHIND_PROXY="y" && echo "http_proxy=${http_proxy}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} http_proxy"
655 [ -n "${https_proxy}" ] && OSM_BEHIND_PROXY="y" && echo "https_proxy=${https_proxy}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} https_proxy"
656 [ -n "${HTTP_PROXY}" ] && OSM_BEHIND_PROXY="y" && echo "HTTP_PROXY=${HTTP_PROXY}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} HTTP_PROXY"
657 [ -n "${HTTPS_PROXY}" ] && OSM_BEHIND_PROXY="y" && echo "https_proxy=${HTTPS_PROXY}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} HTTPS_PROXY"
658 [ -n "${no_proxy}" ] && echo "no_proxy=${no_proxy}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} no_proxy"
659 [ -n "${NO_PROXY}" ] && echo "NO_PROXY=${NO_PROXY}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} NO_PROXY"
660
661 echo "OSM_BEHIND_PROXY=${OSM_BEHIND_PROXY}"
662 echo "OSM_PROXY_ENV_VARIABLES=${OSM_PROXY_ENV_VARIABLES}"
663
664 if [ -n "${OSM_BEHIND_PROXY}" ]; then
665 [ -z "$ASSUME_YES" ] && ! ask_user "
666The following env variables have been found for the current user:
667${OSM_PROXY_ENV_VARIABLES}.
668
669This suggests that this machine is behind a proxy and a special configuration is required.
670The installer will install Docker CE, LXD and Juju to work behind a proxy using those
671env variables.
672
673Take into account that the installer uses apt, curl, wget, docker, lxd, juju and snap.
674Depending on the program, the env variables to work behind a proxy might be different
675(e.g. http_proxy vs HTTP_PROXY).
676
677For that reason, it is strongly recommended that at least http_proxy, https_proxy, HTTP_PROXY
678and HTTPS_PROXY are defined.
679
680Finally, some of the programs (apt, snap) those programs are run as sudoer, requiring that
681those env variables are also set for root user. If you are not sure whether those variables
682are configured for the root user, you can stop the installation now.
683
684Do you want to proceed with the installation (Y/n)? " y && echo "Cancelled!" && exit 1
685 else
686 echo "This machine is not behind a proxy"
687 fi
688
689 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
690}
691
692function find_devops_folder() {
693 if [ -z "$OSM_DEVOPS" ]; then
694 if [ -n "$TEST_INSTALLER" ]; then
695 echo -e "\nUsing local devops repo for OSM installation"
696 OSM_DEVOPS="$(dirname $(realpath $(dirname $0)))"
697 else
698 echo -e "\nCreating temporary dir for OSM installation"
699 OSM_DEVOPS="$(mktemp -d -q --tmpdir "installosm.XXXXXX")"
700 trap 'rm -rf "$OSM_DEVOPS"' EXIT
701 git clone https://osm.etsi.org/gerrit/osm/devops.git $OSM_DEVOPS
702 fi
703 fi
704}
705
706function install_osm() {
707 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
708
709 trap ctrl_c INT
710
711 # TODO: move this under start
712 [ -n "$DOCKER_REGISTRY_URL" ] && parse_docker_registry_url
713
714 check_osm_behind_proxy
715 track checks proxy_ok
716
717 check_packages "git wget curl tar snapd"
718
719 sudo snap install jq || FATAL "Could not install jq (snap package). Make sure that snap works"
720
721 find_devops_folder
722
723 # TODO: the use of stacks come from docker-compose. We should probably remove
724 [ "${OSM_STACK_NAME}" == "osm" ] || OSM_DOCKER_WORK_DIR="$OSM_WORK_DIR/stack/$OSM_STACK_NAME"
725
726 track start release $RELEASE none none docker_tag $OSM_DOCKER_TAG none none installation_type $OSM_INSTALLATION_TYPE none none
727
728 track checks checkingroot_ok
729 [ "$USER" == "root" ] && FATAL "You are running the installer as root. The installer is prepared to be executed as a normal user with sudo privileges."
730 track checks noroot_ok
731
732 ask_proceed
garciadeblas4d89c372021-11-25 11:57:18 +0100733 track checks proceed_ok
vijaynag8339ed22019-07-25 17:10:58 +0530734
garciadeblas0bc87522021-10-20 22:16:17 +0200735 echo "Installing OSM"
736
737 echo "Determining IP address of the interface with the default route"
garciadeblas45ab04c2022-11-25 10:59:03 +0100738 [ -z "$OSM_DEFAULT_IF" ] && OSM_DEFAULT_IF=$(ip route list|awk '$1=="default" {print $5; exit}')
739 [ -z "$OSM_DEFAULT_IF" ] && OSM_DEFAULT_IF=$(route -n |awk '$1~/^0.0.0.0/ {print $8; exit}')
740 [ -z "$OSM_DEFAULT_IF" ] && FATAL "Not possible to determine the interface with the default route 0.0.0.0"
741 OSM_DEFAULT_IP=`ip -o -4 a s ${OSM_DEFAULT_IF} |awk '{split($4,a,"/"); print a[1]; exit}'`
742 [ -z "$OSM_DEFAULT_IP" ] && FATAL "Not possible to determine the IP address of the interface with the default route"
garciadeblas0bc87522021-10-20 22:16:17 +0200743
744 # configure apt proxy
745 [ -n "$APT_PROXY_URL" ] && configure_apt_proxy $APT_PROXY_URL
Mike Marchettib8420852018-09-13 13:45:06 -0400746
747 # if no host is passed in, we need to install lxd/juju, unless explicilty asked not to
David Garcia79f4f532020-04-07 12:59:34 +0200748 if [ -z "$OSM_VCA_HOST" ] && [ -z "$INSTALL_NOLXD" ] && [ -z "$LXD_CLOUD_FILE" ]; then
garciadeblas45ab04c2022-11-25 10:59:03 +0100749 LXD_INSTALL_OPTS="-D ${OSM_DEVOPS} -i ${OSM_DEFAULT_IF} ${DEBUG_INSTALL}"
garciadeblasfa3eb332022-11-15 14:11:56 +0100750 [ -n "${OSM_BEHIND_PROXY}" ] && LXD_INSTALL_OPTS="${LXD_INSTALL_OPTS} -P"
garciadeblas8fed1082022-08-29 11:25:02 +0200751 $OSM_DEVOPS/installers/install_lxd.sh ${LXD_INSTALL_OPTS} || FATAL_TRACK lxd "install_lxd.sh failed"
garciadeblasd41f5482018-05-25 10:25:06 +0200752 fi
David Garcia79f4f532020-04-07 12:59:34 +0200753
garciadeblas4d89c372021-11-25 11:57:18 +0100754 track prereq prereqok_ok
Mike Marchettib8420852018-09-13 13:45:06 -0400755
garciadeblas95804f82021-11-08 23:02:01 +0100756 if [ ! -n "$INSTALL_NODOCKER" ]; then
757 DOCKER_CE_OPTS="-D ${OSM_DEVOPS} ${DEBUG_INSTALL}"
758 [ -n "${DOCKER_PROXY_URL}" ] && DOCKER_CE_OPTS="${DOCKER_CE_OPTS} -p ${DOCKER_PROXY_URL}"
garciadeblasfa3eb332022-11-15 14:11:56 +0100759 [ -n "${OSM_BEHIND_PROXY}" ] && DOCKER_CE_OPTS="${DOCKER_CE_OPTS} -P"
garciadeblas4d89c372021-11-25 11:57:18 +0100760 $OSM_DEVOPS/installers/install_docker_ce.sh ${DOCKER_CE_OPTS} || FATAL_TRACK docker_ce "install_docker_ce.sh failed"
garciadeblas95804f82021-11-08 23:02:01 +0100761 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200762
garciadeblas4d89c372021-11-25 11:57:18 +0100763 track docker_ce docker_ce_ok
David Garcia6cbfee12020-10-23 10:40:20 +0200764
765 echo "Creating folders for installation"
garciadeblas0bc87522021-10-20 22:16:17 +0200766 [ ! -d "$OSM_DOCKER_WORK_DIR" ] && sudo mkdir -p $OSM_DOCKER_WORK_DIR
767 [ ! -d "$OSM_DOCKER_WORK_DIR/osm_pla" -a -n "$INSTALL_PLA" ] && sudo mkdir -p $OSM_DOCKER_WORK_DIR/osm_pla
768 sudo cp -b $OSM_DEVOPS/installers/docker/cluster-config.yaml $OSM_DOCKER_WORK_DIR/cluster-config.yaml
David Garcia6cbfee12020-10-23 10:40:20 +0200769
garciadeblas45ab04c2022-11-25 10:59:03 +0100770 $OSM_DEVOPS/installers/install_kubeadm_cluster.sh -i ${OSM_DEFAULT_IP} -d ${OSM_DOCKER_WORK_DIR} -D ${OSM_DEVOPS} ${DEBUG_INSTALL} || \
garciadeblas4d89c372021-11-25 11:57:18 +0100771 FATAL_TRACK k8scluster "install_kubeadm_cluster.sh failed"
772 track k8scluster k8scluster_ok
David Garcia6cbfee12020-10-23 10:40:20 +0200773
garciadeblas45ab04c2022-11-25 10:59:03 +0100774 JUJU_OPTS="-D ${OSM_DEVOPS} -s ${OSM_STACK_NAME} -i ${OSM_DEFAULT_IP} ${DEBUG_INSTALL} ${INSTALL_NOJUJU} ${INSTALL_CACHELXDIMAGES}"
garciadeblas0bc87522021-10-20 22:16:17 +0200775 [ -n "${OSM_VCA_HOST}" ] && JUJU_OPTS="$JUJU_OPTS -H ${OSM_VCA_HOST}"
776 [ -n "${LXD_CLOUD_FILE}" ] && JUJU_OPTS="$JUJU_OPTS -l ${LXD_CLOUD_FILE}"
777 [ -n "${LXD_CRED_FILE}" ] && JUJU_OPTS="$JUJU_OPTS -L ${LXD_CRED_FILE}"
778 [ -n "${CONTROLLER_NAME}" ] && JUJU_OPTS="$JUJU_OPTS -K ${CONTROLLER_NAME}"
garciadeblasfa3eb332022-11-15 14:11:56 +0100779 [ -n "${OSM_BEHIND_PROXY}" ] && JUJU_OPTS="${JUJU_OPTS} -P"
garciadeblas4d89c372021-11-25 11:57:18 +0100780 $OSM_DEVOPS/installers/install_juju.sh ${JUJU_OPTS} || FATAL_TRACK juju "install_juju.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +0200781 set_vca_variables
garciadeblas4d89c372021-11-25 11:57:18 +0100782 track juju juju_ok
Adam Israel5ddc97f2019-09-03 18:11:12 -0400783
Benjamin Diazba2cca92018-11-08 21:07:15 -0300784 if [ -z "$OSM_DATABASE_COMMONKEY" ]; then
785 OSM_DATABASE_COMMONKEY=$(generate_secret)
786 [ -z "OSM_DATABASE_COMMONKEY" ] && FATAL "Cannot generate common db secret"
787 fi
vijaynag8339ed22019-07-25 17:10:58 +0530788
David Garcia6cbfee12020-10-23 10:40:20 +0200789 # Deploy OSM services
Mike Marchettib8420852018-09-13 13:45:06 -0400790 [ -z "$DOCKER_NOBUILD" ] && generate_docker_images
garciadeblas4d89c372021-11-25 11:57:18 +0100791 track docker_images docker_images_ok
vijaynag8339ed22019-07-25 17:10:58 +0530792
garciadeblas0bc87522021-10-20 22:16:17 +0200793 generate_k8s_manifest_files
garciadeblas4d89c372021-11-25 11:57:18 +0100794 track osm_files manifest_files_ok
garciadeblasd8bc5c32018-05-09 17:37:56 +0200795 generate_docker_env_files
garciadeblas4d89c372021-11-25 11:57:18 +0100796 track osm_files env_files_ok
Mike Marchettib8420852018-09-13 13:45:06 -0400797
garciadeblas0bc87522021-10-20 22:16:17 +0200798 deploy_charmed_services
garciadeblas4d89c372021-11-25 11:57:18 +0100799 track deploy_osm deploy_charmed_services_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200800 kube_secrets
garciadeblas4d89c372021-11-25 11:57:18 +0100801 track deploy_osm kube_secrets_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200802 update_manifest_files
garciadeblas4d89c372021-11-25 11:57:18 +0100803 track deploy_osm update_manifest_files_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200804 namespace_vol
garciadeblas4d89c372021-11-25 11:57:18 +0100805 track deploy_osm namespace_vol_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200806 deploy_osm_services
garciadeblas4d89c372021-11-25 11:57:18 +0100807 track deploy_osm deploy_osm_services_k8s_ok
garciadeblas7b53d262022-11-04 23:18:48 +0100808 if [ -n "$INSTALL_PLA" ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200809 # optional PLA install
810 deploy_osm_pla_service
garciadeblas4d89c372021-11-25 11:57:18 +0100811 track deploy_osm deploy_osm_pla_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200812 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200813 if [ -n "$INSTALL_K8S_MONITOR" ]; then
814 # install OSM MONITORING
815 install_k8s_monitoring
garciadeblas4d89c372021-11-25 11:57:18 +0100816 track deploy_osm install_k8s_monitoring_ok
vijaynag8339ed22019-07-25 17:10:58 +0530817 fi
garciadeblas7b53d262022-11-04 23:18:48 +0100818 if [ -n "$INSTALL_NGSA" ]; then
819 # optional PLA install
820 install_osm_ngsa_service
821 track deploy_osm install_osm_ngsa_ok
822 fi
vijaynag8339ed22019-07-25 17:10:58 +0530823
Mike Marchettib8420852018-09-13 13:45:06 -0400824 [ -z "$INSTALL_NOHOSTCLIENT" ] && install_osmclient
garciadeblas4d89c372021-11-25 11:57:18 +0100825 track osmclient osmclient_ok
beierlma4a37f72020-06-26 12:55:01 -0400826
garciadeblas4a9adcd2020-07-03 15:32:05 +0000827 echo -e "Checking OSM health state..."
garciadeblas0bc87522021-10-20 22:16:17 +0200828 $OSM_DEVOPS/installers/osm_health.sh -s ${OSM_STACK_NAME} -k || \
garciadeblasf4f0e0f2021-12-03 11:37:40 +0100829 (echo -e "OSM is not healthy, but will probably converge to a healthy state soon." && \
garciadeblas0bc87522021-10-20 22:16:17 +0200830 echo -e "Check OSM status with: kubectl -n ${OSM_STACK_NAME} get all" && \
garciadeblasf4f0e0f2021-12-03 11:37:40 +0100831 track healthchecks osm_unhealthy didnotconverge)
garciadeblas4d89c372021-11-25 11:57:18 +0100832 track healthchecks after_healthcheck_ok
vijaynag8339ed22019-07-25 17:10:58 +0530833
garciadeblas0bc87522021-10-20 22:16:17 +0200834 add_local_k8scluster
garciadeblas4d89c372021-11-25 11:57:18 +0100835 track final_ops add_local_k8scluster_ok
garciadeblase92a18d2020-07-03 16:24:23 +0000836
Gulsum Atici3d3a7672023-02-01 11:15:52 +0300837 arrange_docker_default_network_policy
Gulsum Atici5e263302023-01-30 19:11:31 +0300838
garciadeblas89c5f552022-11-24 20:16:57 +0100839 wget -q -O- https://osm-download.etsi.org/ftp/osm-13.0-thirteen/README2.txt &> /dev/null
garciadeblas6c66abf2018-05-16 14:46:19 +0200840 track end
garciadeblas0bc87522021-10-20 22:16:17 +0200841 sudo find /etc/osm
842 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200843 return 0
844}
845
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200846function install_to_openstack() {
garciadeblas0bc87522021-10-20 22:16:17 +0200847 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200848
849 if [ -z "$2" ]; then
850 FATAL "OpenStack installer requires a valid external network name"
851 fi
852
853 # Install Pip for Python3
garciadeblas0bc87522021-10-20 22:16:17 +0200854 sudo apt install -y python3-pip python3-venv
855 sudo -H LC_ALL=C python3 -m pip install -U pip
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200856
Antonio Marsico75a38c72020-12-21 17:29:42 +0100857 # Create a venv to avoid conflicts with the host installation
858 python3 -m venv $OPENSTACK_PYTHON_VENV
859
860 source $OPENSTACK_PYTHON_VENV/bin/activate
861
Antonio Marsicoef3b2362021-03-19 18:54:57 +0100862 # Install Ansible, OpenStack client and SDK, latest openstack version supported is Train
Antonio Marsico75a38c72020-12-21 17:29:42 +0100863 python -m pip install -U wheel
Antonio Marsicoef3b2362021-03-19 18:54:57 +0100864 python -m pip install -U "python-openstackclient<=4.0.2" "openstacksdk>=0.12.0,<=0.36.2" "ansible>=2.10,<2.11"
Antonio Marsico75a38c72020-12-21 17:29:42 +0100865
866 # Install the Openstack cloud module (ansible>=2.10)
867 ansible-galaxy collection install openstack.cloud
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200868
869 export ANSIBLE_CONFIG="$OSM_DEVOPS/installers/openstack/ansible.cfg"
870
871 OSM_INSTALLER_ARGS="${REPO_ARGS[@]}"
872
Antonio Marsico75a38c72020-12-21 17:29:42 +0100873 ANSIBLE_VARS="external_network_name=$2 setup_volume=$3 server_name=$OPENSTACK_VM_NAME"
874
875 if [ -n "$OPENSTACK_SSH_KEY_FILE" ]; then
876 ANSIBLE_VARS+=" key_file=$OPENSTACK_SSH_KEY_FILE"
877 fi
878
879 if [ -n "$OPENSTACK_USERDATA_FILE" ]; then
880 ANSIBLE_VARS+=" userdata_file=$OPENSTACK_USERDATA_FILE"
881 fi
882
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200883 # Execute the Ansible playbook based on openrc or clouds.yaml
884 if [ -e "$1" ]; then
885 . $1
Antonio Marsico75a38c72020-12-21 17:29:42 +0100886 ansible-playbook -e installer_args="\"$OSM_INSTALLER_ARGS\"" -e "$ANSIBLE_VARS" \
887 $OSM_DEVOPS/installers/openstack/site.yml
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200888 else
Antonio Marsico75a38c72020-12-21 17:29:42 +0100889 ansible-playbook -e installer_args="\"$OSM_INSTALLER_ARGS\"" -e "$ANSIBLE_VARS" \
890 -e cloud_name=$1 $OSM_DEVOPS/installers/openstack/site.yml
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200891 fi
892
Antonio Marsico75a38c72020-12-21 17:29:42 +0100893 # Exit from venv
894 deactivate
895
garciadeblas0bc87522021-10-20 22:16:17 +0200896 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200897 return 0
898}
899
Gulsum Atici3d3a7672023-02-01 11:15:52 +0300900function arrange_docker_default_network_policy() {
901 echo -e "Fixing firewall so docker and LXD can share the same host without affecting each other."
902 sudo iptables -I DOCKER-USER -j ACCEPT
903 sudo iptables-save | sudo tee /etc/iptables/rules.v4
904 sudo ip6tables-save | sudo tee /etc/iptables/rules.v6
905}
906
romeromonsere366b1a2019-11-19 19:49:26 +0100907function install_k8s_monitoring() {
garciadeblas0bc87522021-10-20 22:16:17 +0200908 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
romeromonsere366b1a2019-11-19 19:49:26 +0100909 # install OSM monitoring
garciadeblas0bc87522021-10-20 22:16:17 +0200910 sudo chmod +x $OSM_DEVOPS/installers/k8s/*.sh
garciadeblas4d89c372021-11-25 11:57:18 +0100911 sudo $OSM_DEVOPS/installers/k8s/install_osm_k8s_monitoring.sh || FATAL_TRACK install_k8s_monitoring "k8s/install_osm_k8s_monitoring.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +0200912 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
romeromonsere366b1a2019-11-19 19:49:26 +0100913}
914
garciadeblasd8bc5c32018-05-09 17:37:56 +0200915function dump_vars(){
garciadeblas0bc87522021-10-20 22:16:17 +0200916 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
917 echo "APT_PROXY_URL=$APT_PROXY_URL"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200918 echo "DEVELOP=$DEVELOP"
garciadeblas0bc87522021-10-20 22:16:17 +0200919 echo "DEBUG_INSTALL=$DEBUG_INSTALL"
920 echo "DOCKER_NOBUILD=$DOCKER_NOBUILD"
921 echo "DOCKER_PROXY_URL=$DOCKER_PROXY_URL"
922 echo "DOCKER_REGISTRY_URL=$DOCKER_REGISTRY_URL"
923 echo "DOCKER_USER=$DOCKER_USER"
924 echo "INSTALL_CACHELXDIMAGES=$INSTALL_CACHELXDIMAGES"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200925 echo "INSTALL_FROM_SOURCE=$INSTALL_FROM_SOURCE"
garciadeblas0bc87522021-10-20 22:16:17 +0200926 echo "INSTALL_K8S_MONITOR=$INSTALL_K8S_MONITOR"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200927 echo "INSTALL_LIGHTWEIGHT=$INSTALL_LIGHTWEIGHT"
garciadeblas0bc87522021-10-20 22:16:17 +0200928 echo "INSTALL_LXD=$INSTALL_LXD"
garciadeblas7b53d262022-11-04 23:18:48 +0100929 echo "INSTALL_NGSA=$INSTALL_NGSA"
garciadeblas0bc87522021-10-20 22:16:17 +0200930 echo "INSTALL_NODOCKER=$INSTALL_NODOCKER"
931 echo "INSTALL_NOJUJU=$INSTALL_NOJUJU"
932 echo "INSTALL_NOLXD=$INSTALL_NOLXD"
garciadeblas6c66abf2018-05-16 14:46:19 +0200933 echo "INSTALL_ONLY=$INSTALL_ONLY"
garciadeblas0bc87522021-10-20 22:16:17 +0200934 echo "INSTALL_PLA=$INSTALL_PLA"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200935 echo "INSTALL_TO_OPENSTACK=$INSTALL_TO_OPENSTACK"
garciadeblas0bc87522021-10-20 22:16:17 +0200936 echo "INSTALL_VIMEMU=$INSTALL_VIMEMU"
937 echo "NO_HOST_PORTS=$NO_HOST_PORTS"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200938 echo "OPENSTACK_PUBLIC_NET_NAME=$OPENSTACK_PUBLIC_NET_NAME"
939 echo "OPENSTACK_OPENRC_FILE_OR_CLOUD=$OPENSTACK_OPENRC_FILE_OR_CLOUD"
940 echo "OPENSTACK_ATTACH_VOLUME=$OPENSTACK_ATTACH_VOLUME"
Antonio Marsico75a38c72020-12-21 17:29:42 +0100941 echo "OPENSTACK_SSH_KEY_FILE"="$OPENSTACK_SSH_KEY_FILE"
942 echo "OPENSTACK_USERDATA_FILE"="$OPENSTACK_USERDATA_FILE"
943 echo "OPENSTACK_VM_NAME"="$OPENSTACK_VM_NAME"
garciadeblas0bc87522021-10-20 22:16:17 +0200944 echo "OSM_DEVOPS=$OSM_DEVOPS"
945 echo "OSM_DOCKER_TAG=$OSM_DOCKER_TAG"
garciadeblas0cd9b882022-02-10 03:11:50 +0100946 echo "OSM_DOCKER_WORK_DIR=$OSM_DOCKER_WORK_DIR"
garciadeblas7b53d262022-11-04 23:18:48 +0100947 echo "OSM_HELM_WORK_DIR=$OSM_HELM_WORK_DIR"
garciadeblas0cd9b882022-02-10 03:11:50 +0100948 echo "OSM_K8S_WORK_DIR=$OSM_K8S_WORK_DIR"
garciadeblas0bc87522021-10-20 22:16:17 +0200949 echo "OSM_STACK_NAME=$OSM_STACK_NAME"
950 echo "OSM_VCA_HOST=$OSM_VCA_HOST"
951 echo "OSM_VCA_PUBKEY=$OSM_VCA_PUBKEY"
952 echo "OSM_VCA_SECRET=$OSM_VCA_SECRET"
953 echo "OSM_WORK_DIR=$OSM_WORK_DIR"
954 echo "PULL_IMAGES=$PULL_IMAGES"
955 echo "RECONFIGURE=$RECONFIGURE"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200956 echo "RELEASE=$RELEASE"
957 echo "REPOSITORY=$REPOSITORY"
958 echo "REPOSITORY_BASE=$REPOSITORY_BASE"
959 echo "REPOSITORY_KEY=$REPOSITORY_KEY"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200960 echo "SHOWOPTS=$SHOWOPTS"
garciadeblas0bc87522021-10-20 22:16:17 +0200961 echo "TEST_INSTALLER=$TEST_INSTALLER"
962 echo "TO_REBUILD=$TO_REBUILD"
963 echo "UNINSTALL=$UNINSTALL"
964 echo "UPDATE=$UPDATE"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200965 echo "Install from specific refspec (-b): $COMMIT_ID"
garciadeblas0bc87522021-10-20 22:16:17 +0200966 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200967}
968
garciadeblas453d4582020-12-16 19:03:10 +0100969function parse_docker_registry_url() {
garciadeblas0bc87522021-10-20 22:16:17 +0200970 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas453d4582020-12-16 19:03:10 +0100971 DOCKER_REGISTRY_USER=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); split(a[1],b,":"); print b[1]}')
972 DOCKER_REGISTRY_PASSWORD=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); split(a[1],b,":"); print b[2]}')
973 DOCKER_REGISTRY_URL=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); print a[2]}')
garciadeblas0bc87522021-10-20 22:16:17 +0200974 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas453d4582020-12-16 19:03:10 +0100975}
976
garciadeblasadcf95e2022-01-28 17:15:39 +0100977function ctrl_c() {
978 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
979 echo "** Trapped CTRL-C"
980 FATAL "User stopped the installation"
981 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
982}
983
garciadeblasd8bc5c32018-05-09 17:37:56 +0200984UNINSTALL=""
985DEVELOP=""
garciadeblasd8bc5c32018-05-09 17:37:56 +0200986UPDATE=""
987RECONFIGURE=""
988TEST_INSTALLER=""
989INSTALL_LXD=""
990SHOWOPTS=""
991COMMIT_ID=""
992ASSUME_YES=""
garciadeblas0bc87522021-10-20 22:16:17 +0200993APT_PROXY_URL=""
garciadeblasd8bc5c32018-05-09 17:37:56 +0200994INSTALL_FROM_SOURCE=""
garciadeblas0bc87522021-10-20 22:16:17 +0200995DEBUG_INSTALL=""
garciadeblas00627272021-05-26 16:54:05 +0200996RELEASE="ReleaseTEN"
Mike Marchettib8420852018-09-13 13:45:06 -0400997REPOSITORY="stable"
garciadeblasfa3eb332022-11-15 14:11:56 +0100998INSTALL_K8S_MONITOR=""
garciadeblas7b53d262022-11-04 23:18:48 +0100999INSTALL_NGSA=""
garciadeblasfa3eb332022-11-15 14:11:56 +01001000INSTALL_PLA=""
1001INSTALL_VIMEMU=""
garciadeblasd8bc5c32018-05-09 17:37:56 +02001002LXD_REPOSITORY_BASE="https://osm-download.etsi.org/repository/osm/lxd"
1003LXD_REPOSITORY_PATH=""
1004INSTALL_LIGHTWEIGHT="y"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001005INSTALL_TO_OPENSTACK=""
1006OPENSTACK_OPENRC_FILE_OR_CLOUD=""
1007OPENSTACK_PUBLIC_NET_NAME=""
1008OPENSTACK_ATTACH_VOLUME="false"
Antonio Marsico75a38c72020-12-21 17:29:42 +01001009OPENSTACK_SSH_KEY_FILE=""
1010OPENSTACK_USERDATA_FILE=""
1011OPENSTACK_VM_NAME="server-osm"
1012OPENSTACK_PYTHON_VENV="$HOME/.virtual-envs/osm"
garciadeblas6c66abf2018-05-16 14:46:19 +02001013INSTALL_ONLY=""
garciadeblas0e596bc2018-05-28 16:04:42 +02001014TO_REBUILD=""
garciadeblasd41f5482018-05-25 10:25:06 +02001015INSTALL_NOLXD=""
garciadeblasa3e26612018-05-30 17:58:55 +02001016INSTALL_NODOCKER=""
Mike Marchettib8420852018-09-13 13:45:06 -04001017INSTALL_NOJUJU=""
garciadeblas0d45bc82018-11-19 14:25:13 +01001018INSTALL_NOHOSTCLIENT=""
garciadeblas0bc87522021-10-20 22:16:17 +02001019INSTALL_CACHELXDIMAGES=""
garciadeblasd8bc5c32018-05-09 17:37:56 +02001020OSM_DEVOPS=
lavadoe07b1642018-10-25 10:58:34 -05001021OSM_VCA_HOST=
1022OSM_VCA_SECRET=
garciadeblasaa3ddf42019-04-04 19:04:32 +02001023OSM_VCA_PUBKEY=
David Garcia79f4f532020-04-07 12:59:34 +02001024OSM_VCA_CLOUDNAME="localhost"
beierlma4a37f72020-06-26 12:55:01 -04001025OSM_VCA_K8S_CLOUDNAME="k8scloud"
Mike Marchettib8420852018-09-13 13:45:06 -04001026OSM_STACK_NAME=osm
1027NO_HOST_PORTS=""
1028DOCKER_NOBUILD=""
1029REPOSITORY_KEY="OSM%20ETSI%20Release%20Key.gpg"
garciadeblas870e60a2018-11-21 16:44:21 +01001030REPOSITORY_BASE="https://osm-download.etsi.org/repository/osm/debian"
Mike Marchettib8420852018-09-13 13:45:06 -04001031OSM_WORK_DIR="/etc/osm"
garciadeblas7b53d262022-11-04 23:18:48 +01001032OSM_DOCKER_WORK_DIR="${OSM_WORK_DIR}/docker"
vijaynag8339ed22019-07-25 17:10:58 +05301033OSM_K8S_WORK_DIR="${OSM_DOCKER_WORK_DIR}/osm_pods"
garciadeblas7b53d262022-11-04 23:18:48 +01001034OSM_HELM_WORK_DIR="${OSM_WORK_DIR}/helm"
vijaynag8339ed22019-07-25 17:10:58 +05301035OSM_HOST_VOL="/var/lib/osm"
1036OSM_NAMESPACE_VOL="${OSM_HOST_VOL}/${OSM_STACK_NAME}"
Mike Marchetti13d76c82018-09-19 15:00:36 -04001037OSM_DOCKER_TAG=latest
garciadeblas0d45bc82018-11-19 14:25:13 +01001038DOCKER_USER=opensourcemano
1039PULL_IMAGES="y"
Benjamin Diazaa0af712018-10-04 14:02:34 -03001040KAFKA_TAG=2.11-1.0.2
garciadeblas0ab16612022-02-22 14:23:57 +01001041KIWIGRID_K8S_SIDECAR_TAG="1.15.6"
1042PROMETHEUS_TAG=v2.28.1
1043GRAFANA_TAG=8.1.1
lavado6ad812e2019-11-29 10:58:58 -05001044PROMETHEUS_NODE_EXPORTER_TAG=0.18.1
1045PROMETHEUS_CADVISOR_TAG=latest
lavado9a8df7c2018-10-24 09:35:34 -05001046KEYSTONEDB_TAG=10
Benjamin Diazba2cca92018-11-08 21:07:15 -03001047OSM_DATABASE_COMMONKEY=
lavado53eb8f52018-11-16 12:58:23 -05001048ELASTIC_VERSION=6.4.2
lavado4e8662c2018-11-28 11:28:14 -05001049ELASTIC_CURATOR_VERSION=5.5.4
vijaynag8339ed22019-07-25 17:10:58 +05301050POD_NETWORK_CIDR=10.244.0.0/16
1051K8S_MANIFEST_DIR="/etc/kubernetes/manifests"
1052RE_CHECK='^[a-z0-9]([-a-z0-9]*[a-z0-9])?$'
garciadeblas7f1e1042020-11-30 14:07:03 +00001053DOCKER_REGISTRY_URL=
1054DOCKER_PROXY_URL=
1055MODULE_DOCKER_TAG=
garciadeblas4d89c372021-11-25 11:57:18 +01001056OSM_INSTALLATION_TYPE="Default"
garciadeblasd8bc5c32018-05-09 17:37:56 +02001057
garciadeblas0bc87522021-10-20 22:16:17 +02001058while getopts ":a:b:r:n:k:u:R:D:o:O:m:N:H:S:s:t:U:P:A:l:L:K:d:p:T:f:F:-: hy" o; do
garciadeblasd8bc5c32018-05-09 17:37:56 +02001059 case "${o}" in
garciadeblas0bc87522021-10-20 22:16:17 +02001060 a)
1061 APT_PROXY_URL=${OPTARG}
1062 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001063 b)
1064 COMMIT_ID=${OPTARG}
garciadeblas0d45bc82018-11-19 14:25:13 +01001065 PULL_IMAGES=""
garciadeblasd8bc5c32018-05-09 17:37:56 +02001066 ;;
1067 r)
Mike Marchettib8420852018-09-13 13:45:06 -04001068 REPOSITORY="${OPTARG}"
1069 REPO_ARGS+=(-r "$REPOSITORY")
garciadeblasd8bc5c32018-05-09 17:37:56 +02001070 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001071 k)
Mike Marchettib8420852018-09-13 13:45:06 -04001072 REPOSITORY_KEY="${OPTARG}"
1073 REPO_ARGS+=(-k "$REPOSITORY_KEY")
garciadeblasd8bc5c32018-05-09 17:37:56 +02001074 ;;
1075 u)
Mike Marchettib8420852018-09-13 13:45:06 -04001076 REPOSITORY_BASE="${OPTARG}"
1077 REPO_ARGS+=(-u "$REPOSITORY_BASE")
garciadeblasd8bc5c32018-05-09 17:37:56 +02001078 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001079 R)
1080 RELEASE="${OPTARG}"
1081 REPO_ARGS+=(-R "$RELEASE")
garciadeblas0d45bc82018-11-19 14:25:13 +01001082 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001083 D)
1084 OSM_DEVOPS="${OPTARG}"
1085 ;;
garciadeblas6c66abf2018-05-16 14:46:19 +02001086 o)
1087 INSTALL_ONLY="y"
garciadeblasb5a630f2020-03-05 18:32:16 +00001088 [ "${OPTARG}" == "k8s_monitor" ] && INSTALL_K8S_MONITOR="y" && continue
garciadeblasfa3eb332022-11-15 14:11:56 +01001089 [ "${OPTARG}" == "ng-sa" ] && INSTALL_NGSA="y" && continue
garciadeblas6c66abf2018-05-16 14:46:19 +02001090 ;;
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001091 O)
1092 INSTALL_TO_OPENSTACK="y"
1093 if [ -n "${OPTARG}" ]; then
1094 OPENSTACK_OPENRC_FILE_OR_CLOUD="${OPTARG}"
1095 else
1096 echo -e "Invalid argument for -O : ' $OPTARG'\n" >&2
1097 usage && exit 1
1098 fi
1099 ;;
Antonio Marsico75a38c72020-12-21 17:29:42 +01001100 f)
1101 OPENSTACK_SSH_KEY_FILE="${OPTARG}"
1102 ;;
1103 F)
1104 OPENSTACK_USERDATA_FILE="${OPTARG}"
1105 ;;
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001106 N)
1107 OPENSTACK_PUBLIC_NET_NAME="${OPTARG}"
1108 ;;
garciadeblas0e596bc2018-05-28 16:04:42 +02001109 m)
garciadeblas7f1e1042020-11-30 14:07:03 +00001110 [ "${OPTARG}" == "NG-UI" ] && TO_REBUILD="$TO_REBUILD NG-UI" && continue
govindappa79e51b92019-05-22 12:15:21 +05301111 [ "${OPTARG}" == "NBI" ] && TO_REBUILD="$TO_REBUILD NBI" && continue
1112 [ "${OPTARG}" == "LCM" ] && TO_REBUILD="$TO_REBUILD LCM" && continue
1113 [ "${OPTARG}" == "RO" ] && TO_REBUILD="$TO_REBUILD RO" && continue
garciadeblas0e596bc2018-05-28 16:04:42 +02001114 [ "${OPTARG}" == "MON" ] && TO_REBUILD="$TO_REBUILD MON" && continue
govindappa79e51b92019-05-22 12:15:21 +05301115 [ "${OPTARG}" == "POL" ] && TO_REBUILD="$TO_REBUILD POL" && continue
garciadeblas7f1e1042020-11-30 14:07:03 +00001116 [ "${OPTARG}" == "PLA" ] && TO_REBUILD="$TO_REBUILD PLA" && continue
1117 [ "${OPTARG}" == "osmclient" ] && TO_REBUILD="$TO_REBUILD osmclient" && continue
garciadeblas0e596bc2018-05-28 16:04:42 +02001118 [ "${OPTARG}" == "KAFKA" ] && TO_REBUILD="$TO_REBUILD KAFKA" && continue
1119 [ "${OPTARG}" == "MONGO" ] && TO_REBUILD="$TO_REBUILD MONGO" && continue
govindappa79e51b92019-05-22 12:15:21 +05301120 [ "${OPTARG}" == "PROMETHEUS" ] && TO_REBUILD="$TO_REBUILD PROMETHEUS" && continue
garciadeblasfc5bb142019-12-10 10:49:12 +01001121 [ "${OPTARG}" == "PROMETHEUS-CADVISOR" ] && TO_REBUILD="$TO_REBUILD PROMETHEUS-CADVISOR" && continue
govindappa79e51b92019-05-22 12:15:21 +05301122 [ "${OPTARG}" == "KEYSTONE-DB" ] && TO_REBUILD="$TO_REBUILD KEYSTONE-DB" && continue
lavado6ad812e2019-11-29 10:58:58 -05001123 [ "${OPTARG}" == "GRAFANA" ] && TO_REBUILD="$TO_REBUILD GRAFANA" && continue
garciadeblas0e596bc2018-05-28 16:04:42 +02001124 [ "${OPTARG}" == "NONE" ] && TO_REBUILD="$TO_REBUILD NONE" && continue
1125 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001126 H)
1127 OSM_VCA_HOST="${OPTARG}"
1128 ;;
1129 S)
1130 OSM_VCA_SECRET="${OPTARG}"
1131 ;;
1132 s)
garciadeblas0bc87522021-10-20 22:16:17 +02001133 OSM_STACK_NAME="${OPTARG}" && [[ ! "${OPTARG}" =~ $RE_CHECK ]] && echo "Namespace $OPTARG is invalid. Regex used for validation is $RE_CHECK" && exit 0
garciadeblas25e87d22020-01-31 14:27:29 +01001134 ;;
1135 t)
1136 OSM_DOCKER_TAG="${OPTARG}"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001137 REPO_ARGS+=(-t "$OSM_DOCKER_TAG")
garciadeblas25e87d22020-01-31 14:27:29 +01001138 ;;
1139 U)
1140 DOCKER_USER="${OPTARG}"
1141 ;;
1142 P)
1143 OSM_VCA_PUBKEY=$(cat ${OPTARG})
1144 ;;
1145 A)
1146 OSM_VCA_APIPROXY="${OPTARG}"
1147 ;;
David Garcia79f4f532020-04-07 12:59:34 +02001148 l)
1149 LXD_CLOUD_FILE="${OPTARG}"
1150 ;;
1151 L)
1152 LXD_CRED_FILE="${OPTARG}"
1153 ;;
David Garcia404ae122020-04-28 11:47:55 +02001154 K)
1155 CONTROLLER_NAME="${OPTARG}"
1156 ;;
garciadeblas7f1e1042020-11-30 14:07:03 +00001157 d)
1158 DOCKER_REGISTRY_URL="${OPTARG}"
1159 ;;
1160 p)
1161 DOCKER_PROXY_URL="${OPTARG}"
1162 ;;
1163 T)
1164 MODULE_DOCKER_TAG="${OPTARG}"
1165 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001166 -)
1167 [ "${OPTARG}" == "help" ] && usage && exit 0
garciadeblas0d45bc82018-11-19 14:25:13 +01001168 [ "${OPTARG}" == "source" ] && INSTALL_FROM_SOURCE="y" && PULL_IMAGES="" && continue
garciadeblas0bc87522021-10-20 22:16:17 +02001169 [ "${OPTARG}" == "debug" ] && DEBUG_INSTALL="--debug" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001170 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
1171 [ "${OPTARG}" == "uninstall" ] && UNINSTALL="y" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001172 [ "${OPTARG}" == "update" ] && UPDATE="y" && continue
1173 [ "${OPTARG}" == "reconfigure" ] && RECONFIGURE="y" && continue
1174 [ "${OPTARG}" == "test" ] && TEST_INSTALLER="y" && continue
1175 [ "${OPTARG}" == "lxdinstall" ] && INSTALL_LXD="y" && continue
garciadeblasd41f5482018-05-25 10:25:06 +02001176 [ "${OPTARG}" == "nolxd" ] && INSTALL_NOLXD="y" && continue
garciadeblasa3e26612018-05-30 17:58:55 +02001177 [ "${OPTARG}" == "nodocker" ] && INSTALL_NODOCKER="y" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001178 [ "${OPTARG}" == "showopts" ] && SHOWOPTS="y" && continue
Mike Marchettib8420852018-09-13 13:45:06 -04001179 [ "${OPTARG}" == "nohostports" ] && NO_HOST_PORTS="y" && continue
garciadeblas0bc87522021-10-20 22:16:17 +02001180 [ "${OPTARG}" == "nojuju" ] && INSTALL_NOJUJU="--nojuju" && continue
Mike Marchettib8420852018-09-13 13:45:06 -04001181 [ "${OPTARG}" == "nodockerbuild" ] && DOCKER_NOBUILD="y" && continue
1182 [ "${OPTARG}" == "nohostclient" ] && INSTALL_NOHOSTCLIENT="y" && continue
garciadeblas0d45bc82018-11-19 14:25:13 +01001183 [ "${OPTARG}" == "pullimages" ] && continue
garciadeblasb5a630f2020-03-05 18:32:16 +00001184 [ "${OPTARG}" == "k8s_monitor" ] && INSTALL_K8S_MONITOR="y" && continue
garciadeblas4d89c372021-11-25 11:57:18 +01001185 [ "${OPTARG}" == "charmed" ] && CHARMED="y" && OSM_INSTALLATION_TYPE="Charmed" && continue
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001186 [ "${OPTARG}" == "bundle" ] && continue
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +02001187 [ "${OPTARG}" == "k8s" ] && continue
1188 [ "${OPTARG}" == "lxd" ] && continue
1189 [ "${OPTARG}" == "lxd-cred" ] && continue
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001190 [ "${OPTARG}" == "microstack" ] && continue
David Garcia4bd2bf02021-05-05 19:01:43 +02001191 [ "${OPTARG}" == "overlay" ] && continue
David Garcia1bc71022021-05-03 18:27:18 +02001192 [ "${OPTARG}" == "only-vca" ] && continue
aticig5d19ac22022-05-06 13:46:22 +03001193 [ "${OPTARG}" == "small-profile" ] && continue
Dominik Fleischmannc63bed62020-09-25 12:17:54 +02001194 [ "${OPTARG}" == "vca" ] && continue
Dominik Fleischmannc57296f2020-06-09 11:45:08 +02001195 [ "${OPTARG}" == "ha" ] && continue
David Garcia69388c22020-05-07 12:14:19 +02001196 [ "${OPTARG}" == "tag" ] && continue
beierlmf2782c52020-11-05 17:04:05 -05001197 [ "${OPTARG}" == "registry" ] && continue
magnussonl1bbe9452020-02-25 13:43:17 +01001198 [ "${OPTARG}" == "pla" ] && INSTALL_PLA="y" && continue
garciadeblas7b53d262022-11-04 23:18:48 +01001199 [ "${OPTARG}" == "ng-sa" ] && INSTALL_NGSA="y" && continue
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001200 [ "${OPTARG}" == "volume" ] && OPENSTACK_ATTACH_VOLUME="true" && continue
garciadeblas0bc87522021-10-20 22:16:17 +02001201 [ "${OPTARG}" == "nocachelxdimages" ] && continue
1202 [ "${OPTARG}" == "cachelxdimages" ] && INSTALL_CACHELXDIMAGES="--cachelxdimages" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001203 echo -e "Invalid option: '--$OPTARG'\n" >&2
1204 usage && exit 1
1205 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001206 :)
1207 echo "Option -$OPTARG requires an argument" >&2
1208 usage && exit 1
1209 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001210 \?)
1211 echo -e "Invalid option: '-$OPTARG'\n" >&2
1212 usage && exit 1
1213 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001214 h)
1215 usage && exit 0
1216 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001217 y)
1218 ASSUME_YES="y"
1219 ;;
1220 *)
1221 usage && exit 1
1222 ;;
1223 esac
1224done
1225
garciadeblas0bc87522021-10-20 22:16:17 +02001226source $OSM_DEVOPS/common/all_funcs
garciadeblas6c66abf2018-05-16 14:46:19 +02001227
garciadeblas0bc87522021-10-20 22:16:17 +02001228[ -z "${DEBUG_INSTALL}" ] || DEBUG Debug is on
1229[ -n "$SHOWOPTS" ] && dump_vars && exit 0
1230
1231# Uninstall if "--uninstall"
1232if [ -n "$UNINSTALL" ]; then
1233 if [ -n "$CHARMED" ]; then
garciadeblas4d89c372021-11-25 11:57:18 +01001234 ${OSM_DEVOPS}/installers/charmed_uninstall.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D $OSM_DEVOPS -t $DOCKER_TAG "$@" || \
1235 FATAL_TRACK charmed_uninstall "charmed_uninstall.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +02001236 else
garciadeblas4d89c372021-11-25 11:57:18 +01001237 ${OSM_DEVOPS}/installers/uninstall_osm.sh "$@" || \
1238 FATAL_TRACK community_uninstall "uninstall_osm.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +02001239 fi
1240 echo -e "\nDONE"
garciadeblasd8bc5c32018-05-09 17:37:56 +02001241 exit 0
1242fi
1243
garciadeblas0bc87522021-10-20 22:16:17 +02001244# Charmed installation
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001245if [ -n "$CHARMED" ]; then
Mark Beierl70d6f3a2022-12-12 09:00:59 -05001246 sudo snap install jq || FATAL "Could not install jq (snap package). Make sure that snap works"
beierlmce7b4602022-04-13 08:19:40 -04001247 export OSM_TRACK_INSTALLATION_ID="$(date +%s)-$(head /dev/urandom | tr -dc A-Za-z0-9 | head -c 16)"
1248 track start release $RELEASE none none docker_tag $OSM_DOCKER_TAG none none installation_type $OSM_INSTALLATION_TYPE none none
1249 ${OSM_DEVOPS}/installers/charmed_install.sh --tag $OSM_DOCKER_TAG "$@" || \
garciadeblas4d89c372021-11-25 11:57:18 +01001250 FATAL_TRACK charmed_install "charmed_install.sh failed"
garciadeblas89c5f552022-11-24 20:16:57 +01001251 wget -q -O- https://osm-download.etsi.org/ftp/osm-13.0-thirteen/README2.txt &> /dev/null
beierlmce7b4602022-04-13 08:19:40 -04001252 track end installation_type $OSM_INSTALLATION_TYPE
garciadeblas0bc87522021-10-20 22:16:17 +02001253 echo -e "\nDONE"
1254 exit 0
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001255fi
1256
garciadeblas0bc87522021-10-20 22:16:17 +02001257# Installation to Openstack
1258if [ -n "$INSTALL_TO_OPENSTACK" ]; then
1259 install_to_openstack $OPENSTACK_OPENRC_FILE_OR_CLOUD $OPENSTACK_PUBLIC_NET_NAME $OPENSTACK_ATTACH_VOLUME
1260 echo -e "\nDONE"
1261 exit 0
1262fi
1263
1264# Community_installer
garciadeblasfa3eb332022-11-15 14:11:56 +01001265
garciadeblas0bc87522021-10-20 22:16:17 +02001266[ -n "$TO_REBUILD" ] && [ "$TO_REBUILD" != " NONE" ] && echo $TO_REBUILD | grep -q NONE && FATAL "Incompatible option: -m NONE cannot be used with other -m options"
1267[ -n "$TO_REBUILD" ] && [ "$TO_REBUILD" == " PLA" ] && [ -z "$INSTALL_PLA" ] && FATAL "Incompatible option: -m PLA cannot be used without --pla option"
garciadeblasd8bc5c32018-05-09 17:37:56 +02001268# if develop, we force master
1269[ -z "$COMMIT_ID" ] && [ -n "$DEVELOP" ] && COMMIT_ID="master"
garciadeblas0bc87522021-10-20 22:16:17 +02001270OSM_K8S_WORK_DIR="$OSM_DOCKER_WORK_DIR/osm_pods" && OSM_NAMESPACE_VOL="${OSM_HOST_VOL}/${OSM_STACK_NAME}"
garciadeblasb5a630f2020-03-05 18:32:16 +00001271[ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_K8S_MONITOR" ] && install_k8s_monitoring
garciadeblasfa3eb332022-11-15 14:11:56 +01001272[ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_NGSA" ] && install_osm_ngsa_service
garciadeblas6c66abf2018-05-16 14:46:19 +02001273[ -n "$INSTALL_ONLY" ] && echo -e "\nDONE" && exit 0
garciadeblasd8bc5c32018-05-09 17:37:56 +02001274
1275#Installation starts here
garciadeblas89c5f552022-11-24 20:16:57 +01001276wget -q -O- https://osm-download.etsi.org/ftp/osm-13.0-thirteen/README.txt &> /dev/null
garciadeblas4d89c372021-11-25 11:57:18 +01001277export OSM_TRACK_INSTALLATION_ID="$(date +%s)-$(head /dev/urandom | tr -dc A-Za-z0-9 | head -c 16)"
garciadeblas0bc87522021-10-20 22:16:17 +02001278install_osm
garciadeblasd8bc5c32018-05-09 17:37:56 +02001279echo -e "\nDONE"
garciadeblas4d89c372021-11-25 11:57:18 +01001280exit 0